/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


if (typeof jQuery == 'undefined') {
	throw new Error("jquery-storeify requires jQuery");
}

/*
 * jQuery Storeify 0.0.1
 * https://github.com/surgiie/jquery-storeify
 * Author: Sergio Compean
 * Email: scompean24@gmail.com
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 */

;+function ($) {

	$.fn.exists = function () {
		return this.length !== 0;
	};

	$.fn.storeify = function (options) {
		/**
  * =========================
  * Variables
  * =========================
  */
		var values;
		var fields;
		var currentField;
		var formName;

		/**
  * =========================
  * Default plugin options
  * =========================
  */

		var settings = $.extend({

			ignore: ['submit', 'password', 'hidden'],
			storageType: "sessionStorage",
			saveButtonSelector: ".storeify",
			done: null,
			saveOnUnload: true

		}, options);

		/*
  ===================================================================================
  Storeify Plugin Functions
  ===================================================================================
  */

		/**
  * Checks if this current form has existing data in storage
  * @param formName-the forms name attribute value
  * @return boolean;
  */
		function hasExistingData(formName) {
			//does this form have existing data in storage?
			if (window[settings.storageType].getItem(formName)) {
				return true;
			} else {
				return false;
			}
		}

		function saveForm(formName) {

			fields = $("form[name='" + formName + "'] :input");
			values = {};

			$.each(fields, function (index, field) {
				//Check if we should ignore any inputs with a certain type of name
				if (settings.ignore.indexOf($(field).attr('type')) !== -1 || settings.ignore.indexOf($(field).attr('name')) !== -1) {
					return;
				} else {
					switch ($(field).prop('type')) {
						case "radio":
							if (!$(field).is(":checked")) {
								return;
							}
							break;
						case "checkbox":
							if (!$(field).is(":checked")) {
								return;
							}
							break;
						default:
							if ($(field).val() == "") {
								return;
							}
							break;
					}
				}

				values[$(field).attr('name')] = $(field).val();
			});

			//lastly store it in storage
			window[settings.storageType].setItem(formName, JSON.stringify(values));
		}

		if (!$(this).exists()) {
			$.error("The jquerify-storeify selector is not defined");
		}
		/*
  ===================================================================================
  	Start Plugin Processing
  ===================================================================================
  */
		return this.each(function () {

			if (!$(this).is("form")) {
				$.error("The jquerify-storeify selector must be a form");
			} else if ($(this).attr('name') == undefined) {
				$.error("The jquerify-storeify selector name is not defined");
			} else {

				formName = $(this).attr('name');
				//evaluate storage type
				switch (settings.storageType) {
					case "sessionStorage":
						break;
					case "localStorage":
						break;
					default:
						$.error("jquery-storeify: The form(" + formName + ") storageType property value is not a valid Web Storage Type");

				}

				if (hasExistingData(formName)) {

					values = JSON.parse(window[settings.storageType].getItem(formName));

					$.each(values, function (key, value) {

						currentField = $("form[name='" + formName + "'] [name='" + key + "']");

						//if this current field is a radio or check box
						if (currentField.is(":radio") || currentField.is(":checkbox")) {
							//make sure we are setting by value since these types can have duplicates
							$("form[name='" + formName + "'] [value='" + value + "']").prop('checked', true);
						}

						//else its something other than radio/checkbox
						else {
								//so simply set the value
								$(currentField).val(value);
							}
					}); //end loop through storage values  

				}

				// if saveOnUnload setting is false then save on button click .storeify(or settings value)
				if (!settings.saveOnUnload) {
					//when user clicks a save button
					$(settings.saveButtonSelector).on('click ', function () {

						formName = $(this).parents('form:first').attr('name');

						window[settings.storageType].removeItem(formName);

						saveForm(formName);

						if ($.isFunction(settings.done)) {
							settings.done.call(this);
						}
					});
				}

				//else save before page unloads
				else {

						$(window).on('beforeunload ', function () {
							//remove any possible existing values from storage
							window[settings.storageType].removeItem(formName);
							//and save the form
							saveForm(formName);

							if ($.isFunction(settings.done)) {
								settings.done.call(this);
							}
						});
					}

				//remove data on submit
				$("form[name=" + formName + "]").submit(function () {

					window[settings.storageType].removeItem(formName);
				});
			}
		}); //end plugin processing
	};
}($, jQuery);

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(0);


/***/ })
/******/ ]);